﻿/// @file       vcsharp_adc_demo
/// @copyright  Copyright (c) 2014 Toradex AG
/// @author     $ guc $
/// @date       $ 4/1/14 $
/// @brief      This is a Visual C# demo code to demonstrate how to use Toradex ADC Library in C#

using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;                                              ///< To use Toradex C Win32 DLLs

namespace vcsharp_adc_demo
{
     unsafe public partial class Form1 : Form
     {
        [DllImport("ADCLib_Dll.dll", CharSet = CharSet.Auto)]                          ///< Importing DLL
        public static extern Boolean Ac97Init();                                   ///< External function declaration
        [DllImport("ADCLib_Dll.dll", CharSet = CharSet.Auto)]
        public static extern Boolean ReadADCChannel (Int32 channel, Int32 *value, Int32 samples);
        [DllImport("ADCLib_Dll.dll", CharSet = CharSet.Auto)]
        public static extern Int32 MicrovoltsPerLsb (Byte channel);

        public Int32 data = 0;                                                     ///< Temporary Variable that stores raw data from ADC
        public Double temp = 0;
        public Int32 samples = 10;

        public Form1()
        {
            InitializeComponent();
            if (Ac97Init() != true)                                                ///< Initialize AC97 and get a MUTEX for the AC97 access (Touch panel and Sound driver use AC97 too)
            {
               Console.WriteLine("Could not initialize codec\n\r");
            } 
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                fixed (Int32 *Data = &data)
                {
                    ReadADCChannel(0, Data, samples);                              ///< Read ADC channel 0
                }
                temp = Convert.ToDouble((MicrovoltsPerLsb(0) * data) / (1000000.0 * samples));  ///< Gets Conversion constant Microvolts per LSB
                txtChannel1.Text = Convert.ToString(temp);                         ///< Display ADC Channel 0 Analog Value on Text-box
                trackBarChannel1.Value = Convert.ToInt16(temp * 100);              ///< Display ADC Channel 0 Analog Value on Track-bar

                fixed (Int32 *Data = &data)
                {
                    ReadADCChannel(1, Data, samples);                              ///< Read ADC channel 1
                }
                temp = Convert.ToDouble((MicrovoltsPerLsb(1) * data) / (1000000.0 * samples));
                txtChannel2.Text = Convert.ToString(temp);                         ///< Display ADC Channel 1 Analog Value on Text-box
                trackBarChannel2.Value = Convert.ToInt16(temp * 100);              ///< Display ADC Channel 1 Analog Value on Track-bar

                fixed (Int32 *Data = &data)
                {
                    ReadADCChannel(2, Data, samples);                              ///< Read ADC channel 2
                }
                temp = Convert.ToDouble((MicrovoltsPerLsb(2) * data) / (1000000.0 * samples));
                txtChannel3.Text = Convert.ToString(temp);                         ///< Display ADC Channel 2 Analog Value on Text-box
                trackBarChannel3.Value = Convert.ToInt16(temp * 100);              ///< Display ADC Channel 2 Analog Value on Track-bar

                fixed (Int32 *Data = &data)
                {
                    ReadADCChannel(3, Data, samples);                              ///< Read ADC channel 3
                }
                temp = Convert.ToDouble((MicrovoltsPerLsb(3) * data) / (1000000.0 * samples));
                txtChannel4.Text = Convert.ToString(temp);                         ///< Display ADC Channel 3 Analog Value on track-bar
                trackBarChannel4.Value = Convert.ToInt16(temp * 100);              ///< Display ADC Channel 3 Analog Value on track-bar
            }
            catch
            {
                Console.WriteLine("Error: ");
            }
         }
    
    }
}